diff --git a/src/gmt_init.c b/src/gmt_init.c
index 810933861ff..3c59c616e8e 100644
--- a/src/gmt_init.c
+++ b/src/gmt_init.c
@@ -7872,7 +7872,7 @@ int gmt_parse_R_option (struct GMT_CTRL *GMT, char *arg) {
 	}
 	if (i < 4 || i > 6 || ((!GMT->common.R.oblique && gmt_check_region (GMT, p)) || (i == 6 && p[4] >= p[5]))) error++;
 	gmt_M_memcpy (GMT->common.R.wesn, p, 6, double);	/* This will probably be reset by gmt_map_setup */
-	if (i == 6 && !GMT->current.proj.JZ_set) {
+	if (i == 6 && !GMT->current.proj.JZ_set && GMT->current.setting.run_mode == GMT_CLASSIC) {
 		GMT_Report (GMT->parent, GMT_MSG_VERBOSE, "-R with six parameters but no -Jz|Z given - ignore zmin/zmax\n");
 		GMT->common.R.wesn[ZLO] = GMT->common.R.wesn[ZHI] = 0.0;
 	}
@@ -12974,6 +12974,25 @@ struct GMT_CTRL *gmt_init_module (struct GMTAPI_CTRL *API, const char *lib_name,
 				GMT_Report (API, GMT_MSG_DEBUG, "Modern: Adding -J%s to options since there is no history available.\n", scl);
 			}
 		}
+		/* Check if -p was given and if we need to add -Jz|Z from history */
+		if (options && (opt = GMT_Find_Option (API, 'p', *options)) && (opt_R = GMT_Find_Option (API, 'R', *options)) && (gmtlib_count_char (GMT, opt_R->arg, '/') == 5)) {	/* 3-D perspective plotting module with -Rx0/x1/y0/y1/z0/z1 */
+			bool got_JZ = false;
+			char str[3] = {"J"};
+			/* First check if -Jz|Z was not given */
+			for (opt = *options; !got_JZ && opt; opt = opt->next) {
+				if (opt->option == 'J' && strchr ("zZ", opt->arg[0]))
+					got_JZ = true;
+			}
+			
+			if (!got_JZ && (id = gmt_get_option_id (0, "Z")) >= 0 && GMT->init.history[id]) {	/* Did not specify vertical projection but there is history for Z */
+				str[1] = GMT->init.history[id][0];
+				if ((id = gmt_get_option_id (0, str)) >= 0 && GMT->init.history[id]) {	/* There is history for this -Jz|Z */
+					if ((opt = GMT_Make_Option (API, 'J', &str[1])) == NULL) return NULL;	/* Failure to make option -Jz|Z */
+					if ((*options = GMT_Append_Option (API, opt, *options)) == NULL) return NULL;	/* Failure to append option */
+					GMT_Report (API, GMT_MSG_DEBUG, "Modern: Adding -J%c to options since there is history available and -p and -R implies a vertical projection.\n", str[1]);
+				}
+			}
+		}
 	}
 
 	if (options && (opt = GMT_Find_Option (API, GMT_OPT_INFILE, *options))) {
diff --git a/src/gmt_parse.c b/src/gmt_parse.c
index a9f190db0f7..a5360583efb 100644
--- a/src/gmt_parse.c
+++ b/src/gmt_parse.c
@@ -309,9 +309,16 @@ GMT_LOCAL int parse_complete_options (struct GMT_CTRL *GMT, struct GMT_OPTION *o
 			if (opt->arg && opt->arg[0]) {      /* Gave -J<code>[<args>] so we either use or update history and continue */
 				str[1] = opt->arg[0];
 				/* Remember this last -J<code> for later use as -J, but do not remember it when -Jz|Z */
-				if (str[1] != 'Z' && str[1] != 'z' && remember) {
-					gmt_M_str_free (GMT->init.history[id]);
-					GMT->init.history[id] = strdup (&str[1]);
+				if (remember) {
+					if (str[1] == 'Z' || str[1] == 'z') {
+						int z_id = gmt_get_option_id (0, "Z");
+						gmt_M_str_free (GMT->init.history[z_id]);
+						GMT->init.history[z_id] = strdup (&str[1]);
+					}
+					else {
+						gmt_M_str_free (GMT->init.history[id]);
+						GMT->init.history[id] = strdup (&str[1]);
+					}
 				}
 				if (opt->arg[1]) update = true; /* Gave -J<code><args> so we want to update history and continue */
 			}
diff --git a/src/gmt_unique.h b/src/gmt_unique.h
index 0bcaf7a5565..b4759fc98a8 100644
--- a/src/gmt_unique.h
+++ b/src/gmt_unique.h
@@ -57,6 +57,7 @@
 "RG",
 "X",
 "Y",
+"Z",
 "a",
 "b",
 "d",
